const gulp = require('gulp');
const babel = require('gulp-babel');
const rimraf = require('rimraf');
const path = require('path');
const through2 = require('through2');

const cwd = process.cwd();
const libDir = path.join(cwd, 'lib');

function compile() {
  console.log(`libDir: ${libDir}`);
  rimraf.sync(libDir);
  const less = gulp.src(['component/**/*.less'])
    .pipe(through2.obj(function (file, encoding, next) {
      console.log(`处理less--${file.path}`)
      this.push(file.clone());
      next();
    }))
    .pipe(gulp.dest(libDir));

  let error = 0;
  const source = [
    'component/**/index.js'
  ];

  const esjs = gulp.src(source)
    .pipe(through2.obj(function (file, encoding, next) {
      this.push(file.clone());
      next();
    }))
    .pipe(gulp.dest(libDir))
    .pipe(babel({
      presets: ['env', 'react', 'stage-0'],
      plugins: [
        'transform-decorators-legacy',
        'transform-class-properties'
      ]
    }))
    .pipe(through2.obj(function (file, enc, next) {
      // file.path = file.path.replace(/\.es\.js/, '.js');
      this.push(file);
      next();
    }))
    .pipe(gulp.dest(libDir));
}

gulp.task('compile', function () {
  compile();
});